// Ploskev.cpp: implementation of the CPloskev class.
//
//////////////////////////////////////////////////////////////////////

#include "Vector.h"
#include "Ploskev.h"
#include "math.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPloskev::CPloskev()
{

}

CPloskev::~CPloskev()
{

}

CPloskev::CPloskev(CVector BaseVector, CVector RightVector, CVector TopRightVector, CVector TopVector)
{
	m_BaseVector = BaseVector;
	m_RightVector = RightVector;
	m_TopRightVector = TopRightVector;
	m_TopVector = TopVector;
}

void CPloskev::SetBaseVector(CVector Vector)
{
	m_BaseVector = Vector;
}

void CPloskev::SetRightVector(CVector Vector)
{
	m_RightVector = Vector;
}

void CPloskev::SetTopRightVector(CVector Vector)
{
	m_TopRightVector = Vector;
}

void CPloskev::SetTopVector(CVector Vector)
{
	m_TopVector = Vector;
}

CVector CPloskev::GetBaseVector()
{
	return m_BaseVector;
}

CVector CPloskev::GetRightVector()
{
	return m_RightVector;
}

CVector CPloskev::GetTopRightVector()
{
	return m_TopRightVector;
}

CVector CPloskev::GetTopVector()
{
	return m_TopVector;
}

BOOL CPloskev::IsVisible(CVector cvVectorCentra)
{
	BOOL bVisible = TRUE;

	double dFiStozca,dFiVektorja,dSkalarni;
	double dPolmer = m_TopRightVector.GetNorm();
	dFiStozca = atan(dPolmer/cvVectorCentra.GetNorm());
	dFiVektorja = acos((cvVectorCentra*m_TopRightVector)/(cvVectorCentra.GetNorm()*m_TopRightVector.GetNorm()));
	dSkalarni = cvVectorCentra*m_TopRightVector;
	if ((dSkalarni < 0.0) || (dFiVektorja < dFiStozca))
	{
		bVisible = FALSE;
	}
	return bVisible;
}

double CPloskev::GetTezisceX()
{
	double dTezisceX;
	
	dTezisceX = (m_BaseVector.GetX() + m_RightVector.GetX() + m_TopRightVector.GetX() + m_TopVector.GetX())/4.0;

	return dTezisceX;
}

double CPloskev::GetTezisceZ()
{
	double dTezisceZ;
	
	dTezisceZ = (m_BaseVector.GetZ() + m_RightVector.GetZ() + m_TopRightVector.GetZ() + m_TopVector.GetZ())/4.0;

	return dTezisceZ;
}