// Vector.cpp: implementation of the CVector class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ZBuffer.h"
#include "Vector.h"
#include "math.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CVector::CVector()
{
	m_x = 0;
	m_y = 0;
	m_z = 0;
	m_cpPoint.x = 0;
	m_cpPoint.y = 0;
	m_dOddaljenostOdZaslona = 75;
}

CVector::~CVector()
{

}

CVector::CVector(double x, double y,double z, double dOddaljenostOdZaslona)
{
	m_x = x;
	m_y = y;
	m_z = z;
	m_dOddaljenostOdZaslona = dOddaljenostOdZaslona;
	TransformirajSe();
}

void CVector::SetXYZ(double x, double y, double z)
{
	m_x = x;
	m_y = y;
	m_z = z;
	TransformirajSe();
}

double CVector::GetX()
{
	return m_x;
}

double CVector::GetY()
{
	return m_y;
}

double CVector::GetZ()
{
	return m_z;
}

double CVector::GetNorm()
{
	return sqrt(m_x*m_x + m_y*m_y +m_z*m_z);
}

void CVector::SetX(double x)
{
	m_x = x;
}

void CVector::SetY(double y)
{
	m_y = y;
}

void CVector::SetZ(double z)
{
	m_z = z;
}

void CVector::SetOddaljenostOdZaslona(double dOddaljenostOdZaslona)
{
	m_dOddaljenostOdZaslona = dOddaljenostOdZaslona;
}

double CVector::GetOddaljenostOdZaslona()
{
	return m_dOddaljenostOdZaslona;
}


void CVector::TransformirajSe()
{
	m_cpPoint.x = (int)(m_dOddaljenostOdZaslona*m_y/m_x);
	m_cpPoint.y = (int)(m_z*(sqrt(m_dOddaljenostOdZaslona*m_dOddaljenostOdZaslona + m_cpPoint.x*m_cpPoint.x)/sqrt(m_x*m_x + m_y*m_y)));
}

CPoint CVector::GetTransformedPoint()
{
	TransformirajSe();

	return m_cpPoint;
}
